<?php
// $Id: localizernode.php,v 1.2.2.7 2007/04/04 23:20:06 sun Exp $

function localizernode_find($conditions = NULL, $all = TRUE, $force = FALSE) {
  static $localcache = array();
  
  $cid = $conditions .':'. ($all ? 'all' : 'one');
  if (isset($localcache[$cid]) && !$force) {
    return $localcache[$cid];
  }
  
  $items = array();
  
  $sql = "SELECT * FROM {localizernode}";
  if ($conditions) {
    $sql .= ' WHERE '. $conditions;
  }
  $result = db_query($sql);
  while ($item = db_fetch_object($result)) {
    $items[$item->nid]['nid'] = $item->nid;
    $items[$item->nid]['pid'] = $item->pid;
    $items[$item->nid]['locale'] = $item->locale;
  }
  
  if (!$all) {
    $oneitem = array();
    foreach ($items as $nid => $item) {
      foreach ($item as $key => $value) {
        $oneitem[$key] = $value;
      }
      break;
    }
    $localecache[$cid] = $oneitem;
    return $oneitem;
  }
  else {
    $localecache[$cid] = $items;
    return $items;
  }
}

/**
 * Fetch a single node from translation index.
 */
function localizernode_findbynid($nid, $force = FALSE) {
  return localizernode_find("nid=$nid", FALSE, $force);
}

function localizernode_save($item) {
  if (db_result(db_query("SELECT COUNT(nid) FROM {localizernode} WHERE nid=%d", $item['nid'])) > 0) {
    localizernode_update($item);
  }
  else {
    if (!$item['pid']) {
      $item['pid'] = $item['nid'];
    }
    localizernode_insert($item);
  }
}

function localizernode_insert($item) {
  if ($item) {
    db_query("INSERT INTO {localizernode} (nid, pid, locale) VALUES (%d, %d, '%s')", $item['nid'], $item['pid'], $item['locale']);
  }
}

function localizernode_update($item) {
  if ($item) {
    db_query("UPDATE {localizernode} SET pid=%d, locale='%s' WHERE nid=%d", $item['pid'], $item['locale'], $item['nid']);
  }
}

/**
 * Delete a node reference in localizer's index.
 *
 * @todo If a parent node is deleted, all translations of this node have to be
 *       deleted, too.
 */
function localizernode_delete($nid) {
  if ($nid) {
    db_query('DELETE FROM {localizernode} WHERE nid='. $nid);
  }
}

function localizernode_delete_all($conditions) {
  if ($conditions) {
    db_query('DELETE FROM {localizernode} WHERE '. $conditions);
  }
}

